#define minigame_classic_pong_bt_init
// Init Classic Pong Game by BadToxic


global.minigame_classic_pong_bt_vars = ds_list_create();                                    // Data


/*00*/ ds_list_add(global.minigame_classic_pong_bt_vars, 0);                                   // State (Titelscreen=0, Singleplayer=1, Lokal_Multiplayer=2)
/*01*/ ds_list_add(global.minigame_classic_pong_bt_vars, 0);                                   // Menue item (Singleplayer=0, Lokal_Multiplayer=1, Quit=2)
/*02*/ ds_list_add(global.minigame_classic_pong_bt_vars, font_add("Courier New", 20, true, true, 32, 128)); // Font - TitleScreen (only in HTML5)
/*03*/ ds_list_add(global.minigame_classic_pong_bt_vars, font_add("Courier New", 42, true, true, 32, 128)); // Font - Score       (only in HTML5)


/*04*/ ds_list_add(global.minigame_classic_pong_bt_vars, view_yview[0]+view_hview[0]/2-64);    // Player 1 - Y
/*05*/ ds_list_add(global.minigame_classic_pong_bt_vars, ord('W'));                            // Player 1 - Key - Up
/*06*/ ds_list_add(global.minigame_classic_pong_bt_vars, ord('S'));                            // Player 1 - Key - Down
/*07*/ ds_list_add(global.minigame_classic_pong_bt_vars, 0);                                   // Player 1 - Score

/*08*/ ds_list_add(global.minigame_classic_pong_bt_vars, view_yview[0]+view_hview[0]/2-64);    // Player 2 - Y
/*09*/ ds_list_add(global.minigame_classic_pong_bt_vars, vk_up);                               // Player 2 - Key - Up
/*10*/ ds_list_add(global.minigame_classic_pong_bt_vars, vk_down);                             // Player 2 - Key - Down
/*11*/ ds_list_add(global.minigame_classic_pong_bt_vars, 0);                                   // Player 2 - Score

/*12*/ ds_list_add(global.minigame_classic_pong_bt_vars, view_xview[0]+view_wview[0]/2);       // Ball - X
/*13*/ ds_list_add(global.minigame_classic_pong_bt_vars, view_yview[0]+view_hview[0]/2);       // Ball - Y
/*14*/ ds_list_add(global.minigame_classic_pong_bt_vars, 0);                                   // Ball - Speed
/*15*/ ds_list_add(global.minigame_classic_pong_bt_vars, 0);                                   // Ball - Direction
/*16*/ ds_list_add(global.minigame_classic_pong_bt_vars, room_speed*1.2);                      // Ball - Counter

/*17*/ ds_list_add(global.minigame_classic_pong_bt_vars, font_add("Courier New", 10, true, true, 32, 128)); // Font - Footer       (only in HTML5)
/*18*/ ds_list_add(global.minigame_classic_pong_bt_vars, false);                               // Pause - true=yes, false=no

/*19*/ ds_list_add(global.minigame_classic_pong_bt_vars, true);                                // Gamepad1 Use - true=yes, false=no
/*20*/ ds_list_add(global.minigame_classic_pong_bt_vars, true);                                // Gamepad2 Use - true=yes, false=no
/*21*/ ds_list_add(global.minigame_classic_pong_bt_vars, 0);                                   // Gamepad blocker - Used in the menue

#define minigame_classic_pong_bt_draw
// Call this in every draw event, while Classic Pong by BadToxic is running

var xx, yy, i, j, pause;

pause = ds_list_find_value(global.minigame_classic_pong_bt_vars,  18);  // Pause - true=yes, false=no

i = ds_list_find_value(global.minigame_classic_pong_bt_vars, 0); // State (Titelscreen=0, Singleplayer=1, Lokal_Multiplayer=2)

// Background
draw_set_color(c_black);
draw_rectangle(view_xview[0], view_yview[0], view_xview[0]+view_wview[0], view_yview[0]+view_hview[0], false);
// Backgroundline
xx = view_xview[0]+view_wview[0]/2;
yy = view_yview[0]+view_hview[0];
draw_set_color(c_white);
if(i > 0){
    draw_set_alpha(0.5);
    for(j=6; j<yy; j+=20) draw_rectangle(xx-2, j, xx+2, j+8, false);
}

// Footer
draw_set_halign(fa_center);
yy -= 24;
if(os_browser != browser_not_a_browser) draw_set_font(ds_list_find_value(global.minigame_classic_pong_bt_vars, 17)); // Font for footer
if(i > 0) draw_set_alpha(0.1); else draw_set_alpha(0.5);
draw_set_halign(fa_center);
draw_text(xx, yy, "BadToxic");  // Draw: Player 1 - Score
draw_set_alpha(1);

switch(i){
 case 0:{   // Titlescreen
    var str, mouse;
    
    mouse = -1; // Mouseover
    
    // Titel (Classic Pong)
    yy = view_yview[0];
    if(os_browser != browser_not_a_browser){    // Draw: Titel
        draw_set_font(ds_list_find_value(global.minigame_classic_pong_bt_vars, 3)); // Font - Score
        draw_text(xx+5, yy+64, "Classic Pong");
    }
    else draw_text(xx, yy+86, "Classic Pong");  
    draw_set_halign(fa_left);
    
    if(os_browser != browser_not_a_browser) draw_set_font(ds_list_find_value(global.minigame_classic_pong_bt_vars, 2)); // Font for title menue
    
    xx -= 35;
    yy = view_yview[0]+view_hview[0]/2-32;
    
    
    
    i = ds_list_find_value(global.minigame_classic_pong_bt_vars, 1);    // Game Mode
    // Switch through menue
    if(keyboard_check_pressed(ds_list_find_value(global.minigame_classic_pong_bt_vars, 5)) || keyboard_check_pressed(ds_list_find_value(global.minigame_classic_pong_bt_vars, 9))){
        i -= 1;
        if(i < 0) if(os_browser == browser_not_a_browser) i = 2; else  i = 1;
        ds_list_replace(global.minigame_classic_pong_bt_vars, 1, i);    // Game Mode -= 1
    }
    if(keyboard_check_pressed(ds_list_find_value(global.minigame_classic_pong_bt_vars, 6)) || keyboard_check_pressed(ds_list_find_value(global.minigame_classic_pong_bt_vars, 10))){
        i += 1;
        if(os_browser == browser_not_a_browser){ if(i > 2) i = 0; } else { if(i > 1) i = 0; }
        ds_list_replace(global.minigame_classic_pong_bt_vars, 1, i);    // Game Mode += 1
    }
    
    // Use gamepad(s) in menue
    if(ds_list_find_value(global.minigame_classic_pong_bt_vars, 21) <= 0){  // Only if gamepad is not blocked
        for(j=1; j<=2; j+=1) if(joystick_exists(j) && ds_list_find_value(global.minigame_classic_pong_bt_vars, 18+j)){
            switch(joystick_direction(j)){
              case vk_numpad7:
              case vk_numpad8:
              case vk_numpad9:{
                i -= 1;
                if(i < 0) if(os_browser == browser_not_a_browser) i = 2; else  i = 1;
                ds_list_replace(global.minigame_classic_pong_bt_vars, 1, i);            // Game Mode -= 1
                ds_list_replace(global.minigame_classic_pong_bt_vars, 21, room_speed/6);// Block gamepad(s) for 1/6 second
                break;
              }
              case vk_numpad1:
              case vk_numpad2:
              case vk_numpad3:{
                i += 1;
                if(os_browser == browser_not_a_browser){ if(i > 2) i = 0; } else { if(i > 1) i = 0; }
                ds_list_replace(global.minigame_classic_pong_bt_vars, 1, i);            // Game Mode += 1
                ds_list_replace(global.minigame_classic_pong_bt_vars, 21, room_speed/6);// Block gamepad(s) for 1/6 second
                break;
              }
            }
            if(random(joystick_ypos(j)) ==  1){
                i -= 1;
                if(i < 0) if(os_browser == browser_not_a_browser) i = 2; else  i = 1;
                ds_list_replace(global.minigame_classic_pong_bt_vars, 1, i);            // Game Mode -= 1
                ds_list_replace(global.minigame_classic_pong_bt_vars, 21, room_speed/6);// Block gamepad(s) for 1/6 second
                break;
            }
            if(random(joystick_ypos(j)) == -1){
                i += 1;
                if(os_browser == browser_not_a_browser){ if(i > 2) i = 0; } else { if(i > 1) i = 0; }
                ds_list_replace(global.minigame_classic_pong_bt_vars, 1, i);            // Game Mode += 1
                ds_list_replace(global.minigame_classic_pong_bt_vars, 21, room_speed/6);// Block gamepad(s) for 1/6 second
                break;
            }
        }
    }
    
    
    
    if(os_browser == browser_not_a_browser) j=7; else j=0;
    
    // Single Player
    if(mouse_x>=xx-22 && mouse_x<=xx+100 && mouse_y>=yy && mouse_y<=yy+22) {i=0; mouse=0; ds_list_replace(global.minigame_classic_pong_bt_vars, 1, 0);}    // Menue item = Single Player
    if(i == 0) draw_rectangle(xx-22, yy+8, xx-10, yy+20, false);
    str = "1 Player";
    draw_text(xx, yy+j, str);
    
    yy += 24;
    
    // Lokal Multiplayer (2-Players)
    if(mouse_x>=xx-22 && mouse_x<=xx+100 && mouse_y>=yy && mouse_y<=yy+22) {i=1; mouse=1; ds_list_replace(global.minigame_classic_pong_bt_vars, 1, 1);}    // Menue item = Lokal Multiplayer (2-Players)
    if(i == 1) draw_rectangle(xx-22, yy+8, xx-10, yy+20, false);
    str = "2 Player";
    draw_text(xx, yy+j, str);
    
    yy += 24;
    
    // Quit Game    (not in HTML5)
    if(os_browser == browser_not_a_browser){
        if(mouse_x>=xx-22 && mouse_x<=xx+100 && mouse_y>=yy && mouse_y<=yy+22) {i=2; mouse=2; ds_list_replace(global.minigame_classic_pong_bt_vars, 1, 2);} // Menue item = Quit Game
        if(i == 2) draw_rectangle(xx-22, yy+8, xx-10, yy+20, false);
        str = "Quit";
        draw_text(xx, yy+j, str);
    }
    
    if(joystick_exists(1) || joystick_exists(2)){   // Enable/Disable GamePads
        xx = view_xview[0]+20;
        yy = view_yview[0]+view_hview[0]-38;
        if(joystick_exists(1) && joystick_exists(2)) yy-=26;
        for(j=1; j<=2; j+=1) if(joystick_exists(j)){
            draw_rectangle(xx, yy, xx+16, yy+16, true);
            var k;
            k = ds_list_find_value(global.minigame_classic_pong_bt_vars, 18+j); // Is gamepad active?
            if(mouse_check_button_pressed(mb_left)) if(mouse_x>=xx && mouse_x <=xx+16 && mouse_y>=yy && mouse_y <=yy+16) k = !k;
            if(k){draw_line(xx+2, yy+2, xx+14, yy+14); draw_line(xx+2, yy+14, xx+14, yy+2);} else draw_set_alpha(0.6);
            draw_text(xx+22, yy, joystick_name(j));                             // Gamepad name
            draw_set_alpha(1);
            ds_list_replace(global.minigame_classic_pong_bt_vars, 18+j, k);     // Replace old boolean
            yy+=26;
        }
    }
    
    
    // Use selection
    if(keyboard_check_pressed(vk_space) || keyboard_check_pressed(vk_enter)){
        switch(i){  // Game-Mode
         case 0:{ds_list_replace(global.minigame_classic_pong_bt_vars, 0, 1); break;}   // State = 1 -> Single Player
         case 1:{ds_list_replace(global.minigame_classic_pong_bt_vars, 0, 2); break;}   // State = 2 -> Lokal Multiplayer (2-Players)
         case 2:{return false; break;}   // Quit -> exit minigame
        }
    }   // Mouse / Touch
    else if(mouse>=0 && mouse_check_button_pressed(mb_left)){
        switch(mouse){  // Game-Mode
         case 0:{ds_list_replace(global.minigame_classic_pong_bt_vars, 0, 1); break;}   // State = 1 -> Single Player
         case 1:{ds_list_replace(global.minigame_classic_pong_bt_vars, 0, 2); break;}   // State = 2 -> Lokal Multiplayer (2-Players)
         case 2:{return false; break;}   // Quit -> exit minigame
        }
    }   // Gamepad
    else if(ds_list_find_value(global.minigame_classic_pong_bt_vars, 21) <= 0) for(j=1; j<=2; j+=1) if(joystick_exists(j) && ds_list_find_value(global.minigame_classic_pong_bt_vars, 18+j)){
        var k;
        for(k=1; k<=min(4, joystick_buttons(j)); k+=1) if(joystick_check_button(j, k)){
            switch(i){  // Game-Mode
             case 0:{ds_list_replace(global.minigame_classic_pong_bt_vars, 0, 1); break;}   // State = 1 -> Single Player
             case 1:{ds_list_replace(global.minigame_classic_pong_bt_vars, 0, 2); break;}   // State = 2 -> Lokal Multiplayer (2-Players)
             case 2:{return false; break;}   // Quit -> exit minigame
            }
            ds_list_replace(global.minigame_classic_pong_bt_vars, 21, room_speed/3);        // Block gamepad(s) for 1/3 second
            break;
        }
    }
    
    if(keyboard_check_pressed(vk_escape) || (os_type == os_android && keyboard_check_pressed(vk_backspace))) return false;
    else if(ds_list_find_value(global.minigame_classic_pong_bt_vars, 21) <= 0) for(j=1; j<=2; j+=1) if(joystick_exists(j) && ds_list_find_value(global.minigame_classic_pong_bt_vars, 18+j)){
        var k;
        for(k=5; k<=min(8, joystick_buttons(j)); k+=1) if(joystick_check_button(j, k)) return false;
    }
    
    
    break;
 }
 case 1:{ } // Single Player
 case 2:{   //Lokal Multiplayer (2-Players)
    //var ...;
    
    if(os_browser != browser_not_a_browser) draw_set_font(ds_list_find_value(global.minigame_classic_pong_bt_vars, 3)); // Font for Score (Only in HTML5)
    
    // Draw score
    xx = view_xview[0]+view_wview[0]/2;
    yy = view_yview[0]+32;
    draw_set_halign(fa_right);
    draw_text(xx-32, yy, string(ds_list_find_value(global.minigame_classic_pong_bt_vars,  7)));  // Draw: Player 1 - Score
    draw_set_halign(fa_left);
    draw_text(xx+32, yy, string(ds_list_find_value(global.minigame_classic_pong_bt_vars, 11)));  // Draw: Player 2 - Score
    
    // Toogle Pause
    if(keyboard_check_pressed(vk_space) || keyboard_check_pressed(vk_enter) || (os_type == os_android && keyboard_check_pressed(ord('M')))) pause = !pause;
    else if(ds_list_find_value(global.minigame_classic_pong_bt_vars, 21) <= 0) for(j=1; j<=2; j+=1) if(joystick_exists(j) && ds_list_find_value(global.minigame_classic_pong_bt_vars, 18+j)){
        var k;
        for(k=1; k<=min(4, joystick_buttons(j)); k+=1) if(joystick_check_button(j, k)){
            pause = !pause;
            ds_list_replace(global.minigame_classic_pong_bt_vars, 21, room_speed/3);                 // Block gamepad(s) for 1/3 second
        }
    }
    if(pause){
        draw_set_halign(fa_center);
        if(os_browser == browser_not_a_browser) j=8; else j=32;
        draw_text(xx, view_yview[0]+view_hview[0]/2-j, "Pause");
        draw_set_halign(fa_left);
    }
    
    i = ds_list_find_value(global.minigame_classic_pong_bt_vars, 0);    // State -> Game Mode (1=1Player, 2=2Player)
    
    if(!pause){
        j = false;
        // Move players - Player 1
        if(keyboard_check(ds_list_find_value(global.minigame_classic_pong_bt_vars, 5)) || (keyboard_check(ds_list_find_value(global.minigame_classic_pong_bt_vars, 9)) && i==1)){
            ds_list_replace(global.minigame_classic_pong_bt_vars, 4, max(4, ds_list_find_value(global.minigame_classic_pong_bt_vars, 4)-8));
            j = true;
        }
        if(keyboard_check(ds_list_find_value(global.minigame_classic_pong_bt_vars, 6)) || (keyboard_check(ds_list_find_value(global.minigame_classic_pong_bt_vars, 10)) && i==1)){
            ds_list_replace(global.minigame_classic_pong_bt_vars, 4, min(view_yview[0]+view_hview[0]-132, ds_list_find_value(global.minigame_classic_pong_bt_vars, 4)+8));
            j = true;
        }
        if(!j){ // Gamepad(s)
            var k;
            if(i==2) k=1; else k=2; // If only one player - both gamepads can be used
            for(k=k; k>0; k-=1) if(joystick_exists(k) && ds_list_find_value(global.minigame_classic_pong_bt_vars, 18+k)){
                switch(joystick_direction(k)){
                  case vk_numpad7:
                  case vk_numpad8:
                  case vk_numpad9:{ ds_list_replace(global.minigame_classic_pong_bt_vars, 4, max(4, ds_list_find_value(global.minigame_classic_pong_bt_vars, 4)-8)); j = true; break;}
                  case vk_numpad1:
                  case vk_numpad2:
                  case vk_numpad3:{ ds_list_replace(global.minigame_classic_pong_bt_vars, 4, min(view_yview[0]+view_hview[0]-132, ds_list_find_value(global.minigame_classic_pong_bt_vars, 4)+8)); j = true; break;}
                }
                //draw_text(20,20+k*20,string(joystick_direction(k))+" ("+string(vk_numpad7)+", "+string(vk_numpad8)+", "+string(vk_numpad9)+", "+string(vk_numpad1)+", "+string(vk_numpad2)+", "+string(vk_numpad3)+")");
                //draw_text(20,60+k*20,joystick_ypos(k));
                if(j) break;
                if(random(joystick_ypos(k)) ==  1){ ds_list_replace(global.minigame_classic_pong_bt_vars, 4, max(4, ds_list_find_value(global.minigame_classic_pong_bt_vars, 4)-8)); j = true;}
                if(random(joystick_ypos(k)) == -1){ ds_list_replace(global.minigame_classic_pong_bt_vars, 4, min(view_yview[0]+view_hview[0]-132, ds_list_find_value(global.minigame_classic_pong_bt_vars, 4)+8)); j = true;}
                if(j) break;
            }
        }
        if(!j){  // No buttons pressed for player 1 - Check for Touch
            for(j=0; j<5; j+=1){    // Multitouch has up to five fingers at the same time (in GM)
                if(device_mouse_check_button(j, mb_left)){
                    if(device_mouse_x(j) < view_xview[0]+128){
                        var k;
                        k = ds_list_find_value(global.minigame_classic_pong_bt_vars, 4);    // Player 1 - Y
                        if(device_mouse_y(j) < k+56){
                            ds_list_replace(global.minigame_classic_pong_bt_vars, 4, max(4, k-8));
                            break;
                        }
                        else if(device_mouse_y(j) > k+136){
                            ds_list_replace(global.minigame_classic_pong_bt_vars, 4, min(view_yview[0]+view_hview[0]-132, k+8));
                            break;
                        }
                    }
                }
            }
        }
        // Move players - Player 2
        if(i==2){
            j = false;
            if(keyboard_check(ds_list_find_value(global.minigame_classic_pong_bt_vars, 9))){
                ds_list_replace(global.minigame_classic_pong_bt_vars, 8, max(4, ds_list_find_value(global.minigame_classic_pong_bt_vars, 8)-8));
                j = true;
            }
            if(keyboard_check(ds_list_find_value(global.minigame_classic_pong_bt_vars, 10))){
                ds_list_replace(global.minigame_classic_pong_bt_vars, 8, min(view_yview[0]+view_hview[0]-132, ds_list_find_value(global.minigame_classic_pong_bt_vars, 8)+8));
                j = true;
            }
            if(!j){ // Gamepad
                if(joystick_exists(2) && ds_list_find_value(global.minigame_classic_pong_bt_vars, 20)){
                    switch(joystick_direction(2)){
                      case vk_numpad7:
                      case vk_numpad8:
                      case vk_numpad9:{ ds_list_replace(global.minigame_classic_pong_bt_vars, 8, max(4, ds_list_find_value(global.minigame_classic_pong_bt_vars, 8)-8)); j = true; break;}
                      case vk_numpad1:
                      case vk_numpad2:
                      case vk_numpad3:{ ds_list_replace(global.minigame_classic_pong_bt_vars, 8, min(view_yview[0]+view_hview[0]-132, ds_list_find_value(global.minigame_classic_pong_bt_vars, 8)+8)); j = true; break;}
                    }
                    if(!j){
                        if(random(joystick_ypos(2)) ==  1){ ds_list_replace(global.minigame_classic_pong_bt_vars, 8, max(4, ds_list_find_value(global.minigame_classic_pong_bt_vars, 4)-8)); j = true;}
                        if(random(joystick_ypos(2)) == -1){ ds_list_replace(global.minigame_classic_pong_bt_vars, 8, min(view_yview[0]+view_hview[0]-132, ds_list_find_value(global.minigame_classic_pong_bt_vars, 4)+8)); j = true;}
                    }
                }
            }
            if(!j){  // No buttons pressed for player 2 - Check for Touch
                for(j=0; j<5; j+=1){    // Multitouch has up to five fingers at the same time (in GM)
                    if(device_mouse_check_button(j, mb_left)){
                        if(device_mouse_x(j) > view_xview[0]+view_wview[0]-128){
                            var k;
                            k = ds_list_find_value(global.minigame_classic_pong_bt_vars, 8);    // Player 2 - Y
                            if(device_mouse_y(j) < k+56){
                                ds_list_replace(global.minigame_classic_pong_bt_vars, 8, max(4, k-8));
                                break;
                            }
                            else if(device_mouse_y(j) > k+136){
                                ds_list_replace(global.minigame_classic_pong_bt_vars, 8, min(view_yview[0]+view_hview[0]-132, k+8));
                                break;
                            }
                        }
                    }
                }
            }
        }
    }
    
    // Draw players
    xx = view_xview[0];
    yy = ds_list_find_value(global.minigame_classic_pong_bt_vars, 4);   // Player 1 - Y
    draw_rectangle(xx+4, yy, xx+20, yy+128, false);
    
    xx = view_xview[0]+view_wview[0];
    yy = ds_list_find_value(global.minigame_classic_pong_bt_vars, 8);   // Player 2 - Y
    draw_rectangle(xx-20, yy, xx-4, yy+128, false);
    
    // Handle ball
    xx = ds_list_find_value(global.minigame_classic_pong_bt_vars, 12);  // Ball - X
    j  = ds_list_find_value(global.minigame_classic_pong_bt_vars, 13);  // Ball - Y
    if(i==1 && !pause){   // Player 2 - KI
        if(j < yy+56)      yy = min(view_yview[0]+view_hview[0]-132, max(4, yy-8)); // Follow ball-Y
        else if(j > yy+72) yy = min(view_yview[0]+view_hview[0]-132, max(4, yy+8));
        ds_list_replace(global.minigame_classic_pong_bt_vars, 8, yy);   // KI-Update: Player 2 - Y
        
    }
    yy = j; // Restore variable
    if(!pause){
        i  = ds_list_find_value(global.minigame_classic_pong_bt_vars, 16);  // Ball counter - Ball starts at zero
        if(i>=0){
            ds_list_replace(global.minigame_classic_pong_bt_vars, 16, i-1); // Decrease ball counter
            if(i == 0){   // Start ball
                i = floor(random(38))+15;  // Random start angle
                if(floor(random(2)) == 0) i*=-1;  
                if(floor(random(2)) == 0) i+=180;
                if(i<0) i+=360;            
                ds_list_replace(global.minigame_classic_pong_bt_vars, 14, 6); // Ball - Speed
                ds_list_replace(global.minigame_classic_pong_bt_vars, 15, i); // Ball - Direction
            }
        }
        else{   // Move ball
            i = ds_list_find_value(global.minigame_classic_pong_bt_vars, 14); // Ball - Speed
            j = ds_list_find_value(global.minigame_classic_pong_bt_vars, 15); // Ball - Direction
            
            ds_list_replace(global.minigame_classic_pong_bt_vars, 14, i+0.01);// Update: Ball - Speed (continual increase)
        
            xx += lengthdir_x(i, j);    // Update: Ball - X
            yy += lengthdir_y(i, j);    // Update: Ball - Y
        
            // Check wall bounce
            if(yy < view_yview[0]+4){   // Top wall
                yy += 2*(view_yview[0]+4-yy);
                if(j<=90) j = -j;
                else j = 270 - (j-90);
                if(j >= 360) j-=360; else if(j < 0) j+=360;
                ds_list_replace(global.minigame_classic_pong_bt_vars, 15, j); // Ball - Direction
            }
            else if(yy > view_yview[0]+view_hview[0]-4){   // Bottom wall
                yy += 2*(view_yview[0]+view_hview[0]-4-yy);
                if(j>=270) j = -j;
                else j = 90 + (270-j);
                if(j >= 360) j-=360; else if(j < 0) j+=360;
                ds_list_replace(global.minigame_classic_pong_bt_vars, 15, j); // Ball - Direction
            }
            // Check for goal
            else if(xx < view_xview[0]-8){
                ds_list_replace(global.minigame_classic_pong_bt_vars,11, ds_list_find_value(global.minigame_classic_pong_bt_vars, 11)+1);  // Update: Player 2 - Score
                xx = view_xview[0]+view_wview[0]/2;                                                         // Reset: Ball - X
                yy = view_yview[0]+view_hview[0]/2;                                                         // Reset: Ball - y
                ds_list_replace(global.minigame_classic_pong_bt_vars,14, 0);                                // Reset: Ball - Speed
                ds_list_replace(global.minigame_classic_pong_bt_vars,16, room_speed*1.2);                   // Reset: Ball - Counter
            }
            else if(xx > view_xview[0]+view_wview[0]+8){
                ds_list_replace(global.minigame_classic_pong_bt_vars, 7, ds_list_find_value(global.minigame_classic_pong_bt_vars,  7)+1);  // Update: Player 1 - Score
                xx = view_xview[0]+view_wview[0]/2;                                                         // Reset: Ball - X
                yy = view_yview[0]+view_hview[0]/2;                                                         // Reset: Ball - y
                ds_list_replace(global.minigame_classic_pong_bt_vars,14, 0);                                // Reset: Ball - Speed
                ds_list_replace(global.minigame_classic_pong_bt_vars,16, room_speed*1.2);                   // Reset: Ball - Counter
            }
            else{   // Check collisions with players
                if(xx > view_xview[0]-5 && xx < view_xview[0]+25){        // Left side
                    if(j>90 && j<270){
                        var k;
                        k = ds_list_find_value(global.minigame_classic_pong_bt_vars, 4);    // Player 1 - Y
                        if(yy+4>=k && yy-4<=k+128){ // Bounce: Player 1
                            if(j<=180) j = 180-j;
                            else j = 360 - (j-180);
                            xx += 2*lengthdir_x(i, j);
                            ds_list_replace(global.minigame_classic_pong_bt_vars, 15, j); // Ball - Direction
                        }
                    }
                }
                else if(xx > view_xview[0]+view_wview[0]-25 && xx < view_xview[0]+view_wview[0]+5){   // Right side
                    if(j<90 || j>270){
                        var k;
                        k = ds_list_find_value(global.minigame_classic_pong_bt_vars, 8);    // Player 2 - Y
                        if(yy+4>=k && yy-4<=k+128){ // Bounce: Player 2
                            if(j<=180) j = 180-j;
                            else j = 180 + (360-j);
                            xx += 2*lengthdir_x(i, j);
                            ds_list_replace(global.minigame_classic_pong_bt_vars, 15, j); // Ball - Direction
                        }
                    }
                }
            }
            
            ds_list_replace(global.minigame_classic_pong_bt_vars, 12, xx); // Ball - X
            ds_list_replace(global.minigame_classic_pong_bt_vars, 13, yy); // Ball - Y
        }
    }
    // Draw ball
    draw_rectangle(xx-4, yy-4, xx+4, yy+4, false);
    
    // Quit game
    if(keyboard_check_pressed(vk_escape) || keyboard_check_pressed(vk_backspace)){
        if(keyboard_check_pressed(vk_escape) || (os_type == os_android && keyboard_check_pressed(vk_backspace))){
            ds_list_replace(global.minigame_classic_pong_bt_vars, 0, 0);                            // State = 0 -> Back to titlescreen
            pause = false;
        }
        ds_list_replace(global.minigame_classic_pong_bt_vars, 4, view_yview[0]+view_hview[0]/2-64); // Reset: Player 1 - Y
        ds_list_replace(global.minigame_classic_pong_bt_vars, 7, 0);                                // Reset: Player 1 - Score
        ds_list_replace(global.minigame_classic_pong_bt_vars, 8, view_yview[0]+view_hview[0]/2-64); // Reset: Player 2 - Y
        ds_list_replace(global.minigame_classic_pong_bt_vars,11, 0);                                // Reset: Player 2 - Score
        ds_list_replace(global.minigame_classic_pong_bt_vars,12, view_xview[0]+view_wview[0]/2);    // Reset: Ball - X
        ds_list_replace(global.minigame_classic_pong_bt_vars,13, view_yview[0]+view_hview[0]/2);    // Reset: Ball - y
        ds_list_replace(global.minigame_classic_pong_bt_vars,14, 0);                                // Reset: Ball - Speed
        ds_list_replace(global.minigame_classic_pong_bt_vars,16, room_speed*1.2);                   // Reset: Ball - Counter
    }
    else if(ds_list_find_value(global.minigame_classic_pong_bt_vars, 21) <= 0) for(j=1; j<=2; j+=1) if(joystick_exists(j) && ds_list_find_value(global.minigame_classic_pong_bt_vars, 18+j)){
        var k;
        for(k=5; k<=min(8, joystick_buttons(j)); k+=1) if(joystick_check_button(j, k)){
            ds_list_replace(global.minigame_classic_pong_bt_vars, 0, 0);                                // State = 0 -> Back to titlescreen
            pause = false;
            ds_list_replace(global.minigame_classic_pong_bt_vars, 4, view_yview[0]+view_hview[0]/2-64); // Reset: Player 1 - Y
            ds_list_replace(global.minigame_classic_pong_bt_vars, 7, 0);                                // Reset: Player 1 - Score
            ds_list_replace(global.minigame_classic_pong_bt_vars, 8, view_yview[0]+view_hview[0]/2-64); // Reset: Player 2 - Y
            ds_list_replace(global.minigame_classic_pong_bt_vars,11, 0);                                // Reset: Player 2 - Score
            ds_list_replace(global.minigame_classic_pong_bt_vars,12, view_xview[0]+view_wview[0]/2);    // Reset: Ball - X
            ds_list_replace(global.minigame_classic_pong_bt_vars,13, view_yview[0]+view_hview[0]/2);    // Reset: Ball - y
            ds_list_replace(global.minigame_classic_pong_bt_vars,14, 0);                                // Reset: Ball - Speed
            ds_list_replace(global.minigame_classic_pong_bt_vars,16, room_speed*1.2);                   // Reset: Ball - Counter
            ds_list_replace(global.minigame_classic_pong_bt_vars, 21, room_speed/3);                    // Block gamepad(s) for 1/3 second
            break;
        }
    }
    
    break;
 }

}

ds_list_replace(global.minigame_classic_pong_bt_vars, 18, pause);   // Pause - true=yes, false=no
if(ds_list_find_value(global.minigame_classic_pong_bt_vars, 21) > 0) ds_list_replace(global.minigame_classic_pong_bt_vars, 21, ds_list_find_value(global.minigame_classic_pong_bt_vars, 21)-1);// Decrease gamepad block counter

return true;

#define minigame_classic_pong_bt_close
// Call this for closing the Classic Pong by BadToxic and to give free the allocated space

// Delete fonts
font_delete(ds_list_find_value(global.minigame_classic_pong_bt_vars, 2));   // Font - TitleScreen
font_delete(ds_list_find_value(global.minigame_classic_pong_bt_vars, 3));   // Font - Score
font_delete(ds_list_find_value(global.minigame_classic_pong_bt_vars,17));   // Font - Footer

// Delete data structure
ds_list_destroy(global.minigame_classic_pong_bt_vars);

